# HOMEMAKER
Keep making the web your own! Create your own custom static homepage!

live demo: https://home.domdit.com/

#### Features:
- Customizable background images
- Background images persist in new tabs and browser instances through the use of a cookie
- Customizable links
- Links have keybinds so you can type a letter and automatically be redirected to the page of your choice
- Tabbing system to sort your links
- Customizable fonts, colors, links, page title
- Configuration file based generation

## Quickstart:

1. Clone this repository
2. Modify homemaker.conf
3. Put your favorite wallpapers in the folder `bg/`
3. Run `python3 homemaker.py build` to compile your homepage
4. The compiled homepage is now in a folder called `build/`
5. Run `python3 homemaker.py serve`
6. Go to http://localhost:8000 to view your homepage
7. repeat steps 2 through 7 until you have a homepage you are happy with.
8. Take the files in the `build/` folder and host them wherever you host everything else
9. Update all of your browsers so that the home button and new tab button point to your new homepage

## How to Host:

### With your own server using nginx
I am not going to go in depth here. If you have your own server, I would:
- put the compiled files in the `build/` directory in `/var/www/homepage`
- create an nginx config entry that looks something like this:
```
server {
        server_name home.<my-domain>.com www.home.<my-domain>.com;
        
        location / {
                root /var/www/homepage;
        }
}
```
- reload nginx and you are good to go!

### Hosting locally
Similar to hosting remotely, probably, just read for yourself: https://tcude.net/hosting-internal-sites-with-nginx/


